CREATE OR REPLACE PROCEDURE LUCRO_PRESUMIDO(
   P_VROUTRECEITAS  IN IMPOSTO.VRLIMADICLCPR%TYPE,
   P_DTINI          IN MAPAAPURAC.DTINIPERIODO%TYPE,
   P_DTFIN          IN MAPAAPURAC.DTINIPERIODO%TYPE,
   P_CDIMPOSTO      IN MAPAAPURAC.CDIMPOSTO%TYPE,
   P_CDEMPRESA      IN EMPRESA.CDEMPRESA%TYPE,
   P_NRSEQUMAPAPUNF IN MAPAAPURAC.NRSEQUMAPAPU%TYPE
)AS
   VRFATNF       NUMBER;
   VRDEDUNF      NUMBER;
   VRACIMPOS     NUMBER;
   VRTOTACIMPOS  NUMBER;
   BCALCPARC     NUMBER;
   VRALIQPRES    NUMBER;
   VRPERCADICIR  NUMBER;
   VRALIQIMPLCPR NUMBER;
   VRLIMADICLCPR NUMBER;
   VRLUCPRE      NUMBER;
   VRIMPLUCPRE   NUMBER;
   CDTIPOPERFATU VARCHAR2(500);
BEGIN
/******** VERIFICA SE H TIPOS DE OPERES DEFINIDOS OU SE TODAS DEVERO SE CONSIDERADAS( O CAMPO ESTAR NULL)******/
   BEGIN
      SELECT NVL(VRALIQPRES,0), NVL(VRPERCADICIR,0), NVL(VRALIQIMPLCPR,0), NVL(VRLIMADICLCPR,0),CDTIPOPERFATU
       INTO  VRALIQPRES, VRPERCADICIR, VRALIQIMPLCPR, VRLIMADICLCPR, CDTIPOPERFATU
      FROM   IMPOSTO
       WHERE CDIMPOSTO = P_CDIMPOSTO;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
         VRALIQPRES:=0;
         VRPERCADICIR:=0;
         VRALIQIMPLCPR:=0;
         VRLIMADICLCPR :=0;
         CDTIPOPERFATU:= NULL;
   END;
   VRFATNF:=0;
   VRTOTACIMPOS:=0;
   VRDEDUNF:=0;
   VRIMPLUCPRE:=0;
   VRACIMPOS:=0;


 /*************** BUSCA O VALOR DO FATURAMENTO - NOTAS DE SAIDA E ENTRADA DOS TIPOS DE OPERAO DEFINIDOS********************/
   IF (CDTIPOPERFATU IS NOT NULL) THEN
/******* JOGA NULL NO CAMPO NRSEQUMAPAPUNF PARA AS NOTAS DO PERIODO INOFORMADO - ISSO DEVIDO A REAPUAO DE MAPAS********/
      UPDATE NOTAFISCAL NF
      SET NF.NRSEQUMAPAPUNF = NULL
      WHERE EXISTS(SELECT N.NRLANCTONF AS NRLANCTONF, CDFILIAL AS CDFILIAL
                        FROM  NOTAFISCAL N , IMPOSTO IP
                       WHERE  N.CDEMPRESA  = P_CDEMPRESA
                        AND   ((N.IDENTRSAIDOP = 'S' AND N.DTEMISSAO BETWEEN P_DTINI AND P_DTFIN)
                                 OR(N.IDENTRSAIDOP = 'E' AND N.DTENTRSAID BETWEEN P_DTINI AND P_DTFIN))
                        AND   IP.CDIMPOSTO = P_CDIMPOSTO
                        AND   INSTR(IP.CDTIPOPERFATU,N.IDENTRSAIDOP||N.CDTIPOOPER)>0
                        AND   N.IDSTATUS IN ('E','A')
                        AND   N.CDEMPRESA = P_CDEMPRESA
                        AND   N.NRLANCTONF = NF.NRLANCTONF
                        AND   N.CDFILIAL   = NF.CDFILIAL);
                        COMMIT;
      FOR C_FAT IN (SELECT N.VRNOTAFISC AS VRNOTAFISC, N.NRLANCTONF AS NRLANCTONF, CDFILIAL AS CDFILIAL, N.IDENTRSAIDOP AS IDENTRSAIDOP
                     FROM  NOTAFISCAL N , IMPOSTO IP
                    WHERE  N.CDEMPRESA  = P_CDEMPRESA
                     AND   ((N.IDENTRSAIDOP = 'S' AND N.DTEMISSAO BETWEEN P_DTINI AND P_DTFIN)
                              OR(N.IDENTRSAIDOP = 'E' AND N.DTENTRSAID BETWEEN P_DTINI AND P_DTFIN))
                     AND   IP.CDIMPOSTO = P_CDIMPOSTO
                     AND   INSTR(IP.CDTIPOPERFATU,N.IDENTRSAIDOP||N.CDTIPOOPER)>0
                     AND   N.IDSTATUS IN ('E','A')
                     AND   N.CDEMPRESA = P_CDEMPRESA
                     AND   N.NRSEQUMAPAPUNF IS NULL)LOOP
          /********************UPDATE DAS NOTAS FISCAIS QUE ENTRAM NO MAPA********************/

                    UPDATE NOTAFISCAL
                       SET NRSEQUMAPAPUNF = P_NRSEQUMAPAPUNF
                    WHERE  NRLANCTONF = C_FAT.NRLANCTONF
                       AND CDFILIAL   = C_FAT.CDFILIAL
                       AND CDEMPRESA  = P_CDEMPRESA;
                       COMMIT;
          /*************IMPOSTOS QUE ACRESCEM O VALOR DA NF*************************************/
                IF C_FAT.IDENTRSAIDOP = 'S' THEN
                     BEGIN
                       SELECT NVL(SUM(I.VRIMPOSTONF),0)
                        INTO  VRACIMPOS
                        FROM  IMPOSTONF I, IMPOSTO IP
                       WHERE  I.CDFILIAL   = C_FAT.CDFILIAL
                        AND   I.NRLANCTONF = C_FAT.NRLANCTONF
                        AND   I.CDIMPOSTO  = IP.CDIMPOSTO
                        AND   IP.IDTRATIMPO = 'A';
                     EXCEPTION
                      WHEN NO_DATA_FOUND THEN
                        VRACIMPOS:=0;
                     END;
                     VRTOTACIMPOS:=VRACIMPOS+VRTOTACIMPOS;
          /***************SOMA OS VALORES DAS NOTAS FISCAIS PARA ATINGIR O FATRAMENTO TOTAL*******/
                     VRFATNF:=VRFATNF + C_FAT.VRNOTAFISC;
                ELSE
          /***************NOTAS DE ENTRADAS PARA ABATER NO VALOR DO FATURAMENTO********************/
                     VRDEDUNF:=VRDEDUNF + C_FAT.VRNOTAFISC;
                END IF;
      END LOOP;
   ELSE
/******* JOGA NULL NO CAMPO NRSEQUMAPAPUNF PARA AS NOTAS DO PERIODO INOFORMADO - ISSO DEVIDO A REAPUAO DE MAPAS********/
    UPDATE NOTAFISCAL NF
    SET NF.NRSEQUMAPAPUNF = NULL
    WHERE EXISTS(SELECT N.NRLANCTONF AS NRLANCTONF, CDFILIAL AS CDFILIAL
                      FROM  NOTAFISCAL N , IMPOSTO IP
                     WHERE  N.CDEMPRESA  = P_CDEMPRESA
                      AND   ((N.IDENTRSAIDOP = 'S' AND N.DTEMISSAO BETWEEN P_DTINI AND P_DTFIN)
                               OR(N.IDENTRSAIDOP = 'E' AND N.DTENTRSAID BETWEEN P_DTINI AND P_DTFIN))
                      AND   IP.CDIMPOSTO = P_CDIMPOSTO
                      AND   N.IDSTATUS IN ('E','A')
                      AND   N.CDEMPRESA = P_CDEMPRESA
                      AND   N.NRLANCTONF = NF.NRLANCTONF
                      AND   N.CDFILIAL   = NF.CDFILIAL);
                      COMMIT;
    FOR C_FAT IN (SELECT N.VRNOTAFISC AS VRNOTAFISC, N.NRLANCTONF AS NRLANCTONF, CDFILIAL AS CDFILIAL, N.IDENTRSAIDOP AS IDENTRSAIDOP
                     FROM  NOTAFISCAL N , IMPOSTO IP
                    WHERE  N.CDEMPRESA  = P_CDEMPRESA
                     AND   ((N.IDENTRSAIDOP = 'S' AND N.DTEMISSAO BETWEEN P_DTINI AND P_DTFIN)
                              OR(N.IDENTRSAIDOP = 'E' AND N.DTENTRSAID BETWEEN P_DTINI AND P_DTFIN))
                     AND   IP.CDIMPOSTO = P_CDIMPOSTO
                     AND   N.IDSTATUS IN ('E','A')
                     AND   N.CDEMPRESA = P_CDEMPRESA
                     AND   N.NRSEQUMAPAPUNF IS NULL)LOOP
          /********************UPDATE DAS NOTAS FISCAIS QUE ENTRAM NO MAPA********************/

                    UPDATE NOTAFISCAL
                       SET NRSEQUMAPAPUNF = P_NRSEQUMAPAPUNF
                    WHERE  NRLANCTONF = C_FAT.NRLANCTONF
                       AND CDFILIAL   = C_FAT.CDFILIAL
                       AND CDEMPRESA  = P_CDEMPRESA;
                       COMMIT;
          /*************IMPOSTOS QUE ACRESCEM O VALOR DA NF*************************************/
                IF C_FAT.IDENTRSAIDOP = 'S' THEN
                     BEGIN
                       SELECT NVL(SUM(I.VRIMPOSTONF),0)
                        INTO  VRACIMPOS
                        FROM  IMPOSTONF I, IMPOSTO IP
                       WHERE  I.CDFILIAL   = C_FAT.CDFILIAL
                        AND   I.NRLANCTONF = C_FAT.NRLANCTONF
                        AND   I.CDIMPOSTO  = IP.CDIMPOSTO
                        AND   IP.IDTRATIMPO = 'A';
                     EXCEPTION
                      WHEN NO_DATA_FOUND THEN
                        VRACIMPOS:=0;
                     END;
                     VRTOTACIMPOS:=VRACIMPOS+VRTOTACIMPOS;
          /***************SOMA OS VALORES DAS NOTAS FISCAIS PARA ATINGIR O FATRAMENTO TOTAL*******/
                     VRFATNF:=VRFATNF + C_FAT.VRNOTAFISC;
                ELSE
          /***************NOTAS DE ENTRADAS PRA ABATER NO VALOR DO FATURAMENTO********************/
                     VRDEDUNF:=VRDEDUNF + C_FAT.VRNOTAFISC;
                END IF;

      END LOOP;
   END IF;
   /********************CLCULO DA BASE DE CLCULO PARCIAL DO IRPJ******************************************************/
   BCALCPARC:= VRFATNF-VRDEDUNF-VRTOTACIMPOS;
   IF BCALCPARC < 0 THEN
      BCALCPARC:=0;
   END IF;
  /***********CLCULO DO LUCRO PRESUMIDO**********************************/
   VRLUCPRE:= ((BCALCPARC*(VRALIQPRES/100))+ NVL(P_VROUTRECEITAS,0));
   VRIMPLUCPRE:= VRLUCPRE*(VRALIQIMPLCPR/100);
   IF ((VRLUCPRE > VRLIMADICLCPR) AND (VRLIMADICLCPR>0)) THEN
      VRIMPLUCPRE:=VRIMPLUCPRE+ ((VRLUCPRE-VRLIMADICLCPR)*(VRPERCADICIR/100));
   END IF;

   UPDATE MAPARECUP
    SET VRFATBRUTOMAPR = ROUND(BCALCPARC,2)
   WHERE NRSEQUMAPAPU  = P_NRSEQUMAPAPUNF;
   COMMIT;
   UPDATE MAPAAPURAC
    SET IDTPMAPAAPURAC = 'L',
        VRTOTAIMPOS    =  ROUND(VRIMPLUCPRE,2)
   WHERE NRSEQUMAPAPU  =  P_NRSEQUMAPAPUNF;
   COMMIT;
END;
/
