/* Trigger: INSERE_ESTRUTURA_EMPRESA
   Tabela : EMPRESA

   Criao:
   10/02/2014 - Marcelo Alexsandro Souza Silva
*/

CREATE OR REPLACE TRIGGER INSERE_ESTRUTURA_EMPRESA
AFTER INSERT
ON EMPRESA FOR EACH ROW
DECLARE
   V_PRXCODIGO_M           VARCHAR2(20);
   V_PRXCODIGO_H           VARCHAR2(20);
   V_PRXCODIGO_PARCNEGOCIO VARCHAR2(20);
   V_CDSITUCRT             VARCHAR2(01);
   V_DTREFERENCIA          DATE;
   V_COUNT 		            NUMBER;
   V_TIPOINSC 	            VARCHAR2(10);
   V_TIPOPARC 	            VARCHAR2(12);
BEGIN
   V_DTREFERENCIA := TO_DATE('01/01/2000', 'DD/MM/YYYY');
   FOR C_EMPRESA IN
      (SELECT
          :NEW.CDEMPRESA CDEMPRESA,
          :NEW.NRORG NRORG,
          :NEW.NMEMPRESA NMEMPRESA,
          :NEW.NMRAZSOCEMPR NMRAZSOCEMPR,
          REPLACE(REPLACE(REPLACE(REPLACE(:NEW.NRINSJUREMPR, '.',''),'/',''),'-',''),' ','') NRINSJUREMPR
         FROM DUAL
        WHERE NOT EXISTS (SELECT 1
                            FROM ESTRUTURAM
                           WHERE CDINTESTRUTURA = :NEW.CDEMPRESA
                             AND NRTIPOESTRUTURA = 1))
   LOOP
      /*VERIFICA SE A EMPRESA  DO SIMPLES NACIONAL, '3' NAO  DO SIMPLES, APENAS 1 E 2*/
      SELECT NVL(MAX(CDSITUCRT), '3') CDSITUCRT
        INTO V_CDSITUCRT
        FROM PARAMEMPRESA
       WHERE CDEMPRESA = C_EMPRESA.CDEMPRESA;

      NOVO_CODIGO_SC('ESTRUTURAM', V_PRXCODIGO_M);
      NOVO_CODIGO_SC('ESTRUTURAH', V_PRXCODIGO_H);
      NOVO_CODIGO_SC('PARCNEGOCIO', V_PRXCODIGO_PARCNEGOCIO);

      INSERT INTO PARCNEGOCIO(NRPARCNEGOCIO, NRORG, NMPRINCIPALPARC, NMSECUNDARIPARC, NRINSCRICAOPARC,
                              IDATIVO, DTINCLUSAO, CDTIPOINSCRICAO, IDPESSOAFISICA, IDINSTITUICAO,
                              CDTIPOPARCPRINCIPAL)
      VALUES(TO_NUMBER(V_PRXCODIGO_PARCNEGOCIO), C_EMPRESA.NRORG, C_EMPRESA.NMRAZSOCEMPR, C_EMPRESA.NMEMPRESA, NVL(C_EMPRESA.NRINSJUREMPR, C_EMPRESA.CDEMPRESA),
      'S', SYSDATE, 'CNPJ', 'N', 'S', 'ESTRUTURA');

      INSERT INTO ESTRUTURAM(NRESTRUTURAM, CDINTESTRUTURA, NRORG, NRTIPOESTRUTURA, DTINIVIGENCIA, DTINCLUSAO)
      VALUES(TO_NUMBER(V_PRXCODIGO_M), C_EMPRESA.CDEMPRESA, C_EMPRESA.NRORG, 1, V_DTREFERENCIA, SYSDATE);

      INSERT INTO ESTRUTURAH(NRESTRUTURAM, NRESTRUTURAH, NRORG, DTMESCOMPETENC, IDOPTSIMPLES, DTINCLUSAO,
                             CDCNPJESTRUT, NMRAZSOCESTRUT, NRPARCNEGOCIO)
      VALUES(TO_NUMBER(V_PRXCODIGO_M), TO_NUMBER(V_PRXCODIGO_H), C_EMPRESA.NRORG, V_DTREFERENCIA, DECODE(V_CDSITUCRT, '3', 'N', 'S'), SYSDATE,
      C_EMPRESA.NRINSJUREMPR, C_EMPRESA.NMRAZSOCEMPR, TO_NUMBER(V_PRXCODIGO_PARCNEGOCIO));
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('INSERE_ESTRUTURA_EMPRESA','5.70.000'); END;
/
