(function() {

    var ZeedhiDirectives = angular.module('ZeedhiDirectives');
    ZeedhiDirectives.directive('dashboardCard', dashboardCard);

    function dashboardCard() {

        var linkFunction = function(theScope, theElement) {
            var scope = theScope;
            var element = theElement;
            var widget = theScope.widget;

            function setColorByValue() {
                var color;
                var value = widget.value;
                var conditions = widget.cardConditions || [];
                var colors = widget.cardColors || [];

                for (var i = 0; i < conditions.length; i++) {
                    if (value >= conditions[i]) {
                        color = colors[i];
                    }
                }

                widget.color = color;
                element.css('background-color', color);
            }

            setColorByValue();

            scope.$watch(
                function() {
                    return widget.value;
                },
                function(newColor) {
                    setColorByValue();
                    applyWidgetColorOnElement();
                }
            );

            function fontShouldBeWhite(color) {
                var c = color.substring(1); // strip #
                var rgb = parseInt(c, 16); // convert rrggbb to decimal
                var r = (rgb >> 16) & 0xff; // extract red
                var g = (rgb >> 8) & 0xff; // extract green
                var b = (rgb >> 0) & 0xff; // extract blue

                var luma = 0.2126 * r + 0.7152 * g + 0.0722 * b;
                return luma < 155;
            }

            function applyWidgetColorOnElement() {
                if (widget.color) {
                    var color = widget.color || '#e2a53b';
                    if (fontShouldBeWhite(widget.color)) {
                        element.css('color', '#fff');
                    } else {
                        element.css('color', '#000');
                    }
                    element.css('background-color', color);
                }
            }
        };

        return {
            restrict: 'A',
            link: linkFunction
        };
    }



})();